/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_sil.h 948 2008-04-14 08:34:27Z ertl-honda $
 */

/*
 *  sil.hΥ¸ARMѡ
 */

#ifndef TOPPERS_CORE_SIL_H
#define TOPPERS_CORE_SIL_H

#ifndef TOPPERS_MACRO_ONLY
#ifdef __thumb__
#include <core_insn.h>
#endif	/* __thumb__ */

/*
 *  ٤ƤγߡFIQIRQˤζػ
 */
Inline uint32_t
TOPPERS_disint(void)
{
    uint32_t  cpsr;
    uint32_t  irq_fiq_mask;

#ifndef __thumb__
    Asm("mrs  %0,CPSR" : "=r"(cpsr));
#else	/* __thumb__ */
    cpsr = current_sr();
#endif	/* __thumb__ */
    irq_fiq_mask = cpsr & (0x40|0x80);
    cpsr |= (0x40|0x80);
#ifndef __thumb__
    Asm("msr CPSR, %0" : : "r"(cpsr) :"memory", "cc");
#else	/* __thumb__ */
    set_sr(cpsr);
#endif	/* __thumb__ */

    return(irq_fiq_mask);
}

/*
 *  FIQ,IRQ
 */
Inline void
TOPPERS_set_fiq_irq(uint32_t TOPPERS_irq_fiq_mask)
{
    uint32_t  cpsr;

#ifndef __thumb__
    Asm("mrs  %0,CPSR" : "=r"(cpsr));
#else	/* __thumb__ */
    cpsr = current_sr();
#endif	/* __thumb__ */
    cpsr = cpsr & ~(0x40|0x80);
    cpsr = cpsr | (TOPPERS_irq_fiq_mask & (0x40|0x80));
#ifndef __thumb__
    Asm("msr CPSR, %0" : : "r"(cpsr):"memory", "cc");
#else	/* __thumb__ */
    set_sr(cpsr);
#endif	/* __thumb__ */
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC   uint32_t TOPPERS_irq_fiq_mask
#define SIL_LOC_INT() ((void)(TOPPERS_irq_fiq_mask = TOPPERS_disint()))
#define SIL_UNL_INT() (TOPPERS_set_fiq_irq(TOPPERS_irq_fiq_mask))

/*
 *  Ԥ
 */
Inline void
sil_dly_nse(ulong_t dlytim)
{
    register uint32_t r0 asm("r0") = (uint32_t) dlytim;    
    Asm("bl _sil_dly_nse" : "=g"(r0) : "0"(r0) : "lr","cc");
}


#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CORE_SIL_H */
