/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2009      by GJ Designing Center Print Business Group
 *                             RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _MINDSTORMSNXT_H_
#define _MINDSTORMSNXT_H_

#include <sil.h>

#define CLOCK_FREQUENCY 48000000

/*
 * ¢UART ʰSIOɥ饤
 */
#define NUM_SNDBUF  2
#define SIORBUFSIZE 128
#define SIOSBUFSIZE 256
#define SIOBUFSIZE  126

#define SND_EMPY    0
#define SND_RDY     1
#define SND_OUT     2

/*
 *  BLUETOOTH³
 */
#define BLUETOOTH_DEVICE_INITIALIZED    3
#define BLUETOOTH_NO_INIT               4
#define BLUETOOTH_INITIALIZED           5
#define BLUETOOTH_CONNECTED             6
#define BLUETOOTH_STREAM                7
#define BLUETOOTH_CONNECT_ABORT         8
#define BLUETOOTH_CONNECT_ERROR         9

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ԥ󥳡ɤλ꤬ʤΥǥեȤ"1234"Ȥ
 */
#ifndef BLUETOOTH_PINCODE
#define BLUETOOTH_PINCODE       "1234"
#endif

/*
 *  ꥢI/Oݡȥѥå
 */
typedef struct sio_packet
{
	int16_t  id;
	uint16_t len;
	uint8_t  buf[SIOSBUFSIZE];
}
SIOPACKET;

extern ER_BOOL bluetooth_send_ready(ID portid);
extern ER_UINT bluetooth_received_count(ID portid);
extern ER      bluetooth_send(ID portid, SIOPACKET *p);
extern ER_UINT bluetooth_receive(ID portid, unsigned char *buf);
extern ER      bluetooth_get_packet(ID portid, SIOPACKET **ppkt, int_t *plen);
extern ER_UINT bluetooth_get_connect_state(ID portid);
extern ER      bluetooth_set_connect_state(ID portid, int_t state);
extern ER      bluetooth_reset(ID portid);

extern void    bluetooth_clear_arm7_cmd(void);
extern void    bluetooth_set_arm7_cmd(void);

extern void    bluetooth_initialize(intptr_t exinf);
extern uint8_t *bluetooth_get_pincode(void);
extern uint8_t *bluetooth_get_device_address(void);

#endif /* TOPPPERS_MACRO_ONLY */

#if 0	/* ROI DEBUG */


#define IRQ_FIQ_PID     0
#define IRQ_SYSIRQ_PID  1
#define IRQ_PIOA_PID    2
#define IRQ_ADC_PID     4
#define IRQ_SPI_PID     5
#define IRQ_US0_PID     6
#define IRQ_US1_PID     7
#define IRQ_SSC_PID     8
#define IRQ_TWI_PID     9
#define IRQ_PWM_PID     10
#define IRQ_UDP_PID     11
#define IRQ_TC0_PID     12
#define IRQ_TC1_PID     13
#define IRQ_TC2_PID     14
#define IRQ_IRQ0_PID    30
#define IRQ_IRQ1_PID    31

#ifndef SMR_SYSIRQ
#define SMR_SYSIRQ      (AIC_SRCTYPE_INT_EDGE_TRIGGERED|4)
#endif
#ifndef SMR_PIOA
#define SMR_PIOA        (AIC_SRCTYPE_INT_LEVEL_SENSITIVE|4)
#endif
#ifndef SMR_SPI
#define SMR_SPI         (AIC_SRCTYPE_INT_LEVEL_SENSITIVE|4)
#endif
#ifndef SMR_TWI
#define SMR_TWI         (AIC_SRCTYPE_INT_LEVEL_SENSITIVE|5)
#endif
#ifndef SMR_US0
#define SMR_US0         (AIC_SRCTYPE_INT_LEVEL_SENSITIVE|3)
#endif
#ifndef SMR_US1
#define SMR_US1         (AIC_SRCTYPE_INT_LEVEL_SENSITIVE|3)
#endif
#ifndef SMR_SSC
#define SMR_SSC         (AIC_SRCTYPE_INT_EDGE_TRIGGERED|0)
#endif
#ifndef SMR_PMW
#define SMR_PMW         (AIC_SRCTYPE_INT_EDGE_TRIGGERED|2)
#endif
#ifndef SMR_TC0
#define SMR_TC0         (AIC_SRCTYPE_INT_LEVEL_SENSITIVE|4)
#endif
#ifndef SMR_TC1
#define SMR_TC1         (AIC_SRCTYPE_INT_LEVEL_SENSITIVE|3)
#endif
#ifndef SMR_TC2
#define SMR_TC2         (AIC_SRCTYPE_INT_LEVEL_SENSITIVE|3)
#endif


#define MCK	                    48054850
#endif	/* ROI DEBUG */

#endif /* _MINDSTORMSNXT_H_ */
