/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2004-2005 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸƤ GNU General Public Lincense  Version 2 ˵
 *  ҤƤ˸¤ꡢܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *  ɽѾ浪Ӱʲ̵ݾڵ꤬Τޤޤηǥ
 *  ˴ޤޤ뤳ȡ
 *  (2) ܥեȥ򡢥饤֥ꥣʤɡ¾Υեȥȯ˻
 *  ѤǤǺۤˤϡۤȼɥȡѼ
 *  ޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ̵
 *  ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡢵Ȥ߹ʤɡ¾Υեȥȯ˻
 *  ǤʤǺۤˤϡΤ줫ξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡢嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤줤ΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽޤ
 *  ơʤݾԤʤޤܥեȥѤˤľŪ
 *  ϴŪʤ»˴ؤƤ⡢Ǥʤ
 * 
 *  @(#) $Id: mon_tinet.c,v 1.2 2005/10/22 07:33:10 roi Exp roi $
 */

/* 
 *  ǥХå󥽡
 */

#include <t_services.h>
#include "kernel_id.h"

#include <stdio.h>
#include <stdlib.h>

#include "../kernel/jsp_kernel.h"
#include "../kernel/task.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/net.h>
#include <net/if.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/if_ether.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet6/nd6.h>

#include <net/if_var.h>
#include <net/if6_var.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include "netdevice.h"
#include "monitor.h"
#include "tinet_id.h"

/*
 *  ͥåȥ֥ޥ
 */

#define	MONNET_PING		0			/* PING */
#define	MONNET_IFCONFIG	1			/* IFCONFIG */
#define	MONNET_OPEN		2			/* ץ */
#define	MONNET_CLOSE	3			/*  */

/*
 *  ؿ
 */

extern const char *itron_strerror (ER ercd);

/*
 *  ɽޥɥơ֥
 */
static struct SUBCOMMAND_TABLE const mon_net[] = {

	{"PING",     MONNET_PING},		/* PING */
	{"IFCONFIG", MONNET_IFCONFIG},	/* IFCONFIG */
	{"OPEN",     MONNET_OPEN},		/* ǥХץ */
	{"CLOSE",    MONNET_CLOSE}		/* ǥХ */
};

BOOL net_activate = FALSE;
BOOL rcv_flg      = FALSE;


#ifdef SUPPORT_INET4
/*
 *  put_ipv4addrm -- IPv4 ɥ쥹
 */

static int
put_ipv4addrm (UW addr, int width)
{
	int len = 15;

	printf("%03d.", (addr >> 24) & 0xff); 
	printf("%03d.", (addr >> 16) & 0xff); 
	printf("%03d.", (addr >>  8) & 0xff); 
	printf("%03d",  addr        & 0xff); 

	for ( ; len < width; len ++)
		putchar(' ');
	return len;
}

/*
 *  ifconfig -- ͥåȥ󥿥եι
 */

static void
ifconfig (UB *line)
{
	T_IFNET		*ifp = IF_GET_IFNET();
	T_IN4_ADDR	bc;

#ifdef SUPPORT_ETHER
	if (*(line = skip_blanks(line))) {
		T_IN4_ADDR	addr, mask;

		GET_IPADDR(&mask, skip_blanks(GET_IPADDR(&addr, line)));
		in4_add_ifaddr(addr, mask);
	}
#endif	/* of #ifdef SUPPORT_ETHER */

	printf("Network Interface Configurations\n");

#ifdef SUPPORT_ETHER
	printf(     "ether: %M\n",
	            IF_ETHER_NIC_GET_SOFTC()->ifaddr.lladdr);
#endif	/* of #ifdef SUPPORT_ETHER */

	bc = (ifp->in_ifaddr.addr & ifp->in_ifaddr.mask) | ~ifp->in_ifaddr.mask;
	printf("inet:  ");
	put_ipv4addrm(ifp->in_ifaddr.addr, 16);
	printf("mask: ");
	put_ipv4addrm(ifp->in_ifaddr.mask, 16);
	printf("boadcast: ");
	put_ipv4addrm(bc, 0);
	putchar('\n');
}

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6
/*
 *  ipv6addrm -- IPv6 ɥ쥹
 */

static int
put_ipv6addrm (const T_IN6_ADDR addr, int width)
{
	int	len = 0, ix;
	BOOL	omit = FALSE, zero = FALSE;

	for (ix = 0; ix < sizeof(T_IN6_ADDR) / 2; ix ++) {
		if (omit) {
			printf("%04x", addr->s6_addr16[ix]);
			len += 4;
			if (ix < 7) {
				putchar(':');
				len ++;
			}
		}
		else if (ix > 0 && ix < 7 && addr->s6_addr16[ix] == 0)
			zero = TRUE;
		else {
			if (zero) {
				omit = TRUE;
				putchar(':');
				len ++;
			}
			printf("%04x", addr->s6_addr16[ix]);
			len += 4;
			if (ix < 7) {
				putchar(':');
				len ++;
			}
		}
	}

	for ( ; len < width; len ++)
		putchar(' ');

	return len;
}

/*
 *  ifconfig -- ͥåȥ󥿥եι
 */

static void
ifconfig (UB *line)
{
#ifdef SUPPORT_ETHER
	T_IF_SOFTC	*ic;
	T_IFNET		*ifp = IF_GET_IFNET();
	int		ix;
	SYSTIM		now;

	ic = IF_ETHER_NIC_GET_SOFTC();
	printf("ether: %M\ninet6:\nIX   Expire Lifetime RTR Flags IP Address\n",ic->ifaddr.lladdr);

	/* expire  vltime ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	for (ix = 0; ix < MAX_IN6_IFADDR_CNT; ix ++) {
		if (ifp->in_ifaddrs[ix].flags & IN6_IFF_DEFINED) {
			printf(" %d", ix);
			if (ifp->in_ifaddrs[ix].lifetime.vltime == ND6_INFINITE_LIFETIME)
				printf("    INFIN    INFIN");
			else
				printf(" %8d %8d",           (ifp->in_ifaddrs[ix].lifetime.expire - now),
				                             ifp->in_ifaddrs[ix].lifetime.vltime);

			if (ifp->in_ifaddrs[ix].flags & IN6_IFF_AUTOCONF) {
				if (ifp->in_ifaddrs[ix].rtr_index == IN6_RTR_IX_UNREACH)
					printf("   *");
				else
					printf("  %2d", ifp->in_ifaddrs[ix].rtr_index);
			}
			else
				printf("   -");

			printf("    %02x",     ifp->in_ifaddrs[ix].flags);
			put_ipv6addrm(ifp->in_ifaddrs[ix].addr, 20);
		}
	}
#endif	/* of #ifdef SUPPORT_ETHER */
}

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  ͥåȥޥ
 */
UW
net_command(B *command)
{
	T_IPEP dst;
	static T_IPEP src = {
		IP_ADDRANY,
		TCP_PORTANY,
		};
	INT  point=0;
	B    cmd=0;
	T_IN_ADDR	addr;
	int  count, no, tmo, portno;
	ER	error;
	BOOL flag;
	const char *s;
	B   *d, c;

	count = sizeof(mon_net) / sizeof(struct SUBCOMMAND_TABLE);
	if(command[point]){
		for(no = 0 ; no < count ; no++){
			s = mon_net[no].subcommand;
			d = command+point;
			flag = TRUE;
			while(*s != 0 && *d != 0 && *d != ' ' && *d != ','){
				c = *d++;
				if(c >= 'a' && c <= 'z')
					c -= 0x20;
				if(*s++ != c){
					flag = FALSE;
					break;
				}
			}
			if(flag){
				skip_word(command, &point);
				cmd = mon_net[no].type;
				break;
			}
		}
	}
	switch(cmd){
	case MONNET_PING:				/* PING */
		tmo = atoi(skip_blanks((UB *)GET_IPADDR(&addr, command+point)));
		if(tmo <= 0)
			tmo = 10;
		PING(&addr, tmo, 64);
		break;
	case MONNET_IFCONFIG:			/* IFCONFIG */
		ifconfig(command+point);
		break;
#ifndef DEVSERV
	case MONNET_OPEN:				/* ץ */
		portno = atoi(skip_blanks((UB *)GET_IPADDR(&addr, command+point)));
		if(addr > 0)
			dst.ipaddr = addr;
#ifdef SUPPORT_INET4
		else
			dst.ipaddr = (IPV4_ADDR_LOCAL & 0xffffff00) | 6;
#endif
		if(portno > 0)
			dst.portno = portno;
		else
			dst.portno = NET_DEVICE_PORTNO;
		wai_sem(SEMID_NETDEVICE);
		error = TCP_CON_CEP(TCP_NETDEVICE_CEPID, &src, &dst, 60 * 1000);
		printf("tcp_con_cep=%s\n", itron_strerror(error));
		net_activate = TRUE;
		sig_sem(SEMID_NETDEVICE);
		rcv_flg      = TRUE;		/* ׵ */
		wup_tsk(TCP_NETDEVICE_RCV_TASK);
#if defined(START_TASKID) && START_TASKID > 0 && START_TASKID < MONTASK
		act_tsk(START_TASKID);
#endif
		break;
	case MONNET_CLOSE:				/*  */
		wai_sem(SEMID_NETDEVICE);
		net_activate = FALSE;
		if((error = tcp_sht_cep(TCP_NETDEVICE_CEPID)) < 0)
			printf("[TCP NETDEVICE CLI SND] shutdown error: %s\n", itron_strerror(error));

		dly_tsk(1000);
		sig_sem(SEMID_NETDEVICE);
		if ((error = tcp_cls_cep(TCP_NETDEVICE_CEPID, TMO_FEVR)) < 0)
			printf("[TCP NETDEVICE CLI SND] close error: %s\n", itron_strerror(error));
		printf("close\n");
		break;
#endif
	default:						/* ǥե */
		break;
	}
	return 0;
}

