/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *                2003      by  Advanced Data Controls, Corp
 *  Copyright (C) 2009 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: rtos.h,v 1.1 2009/07/18 09:14:24 roi Exp $
 */

#ifndef _RTOS_H_
#define _RTOS_H_

#include <kernel.h>
#include <mindstormsnxt.h>

#ifndef _MACRO_ONLY

#include "mytypes.h"

typedef void * VP_INT;
typedef U32    SYSTIM;
typedef U8     UB;
#ifndef _OSEK_KERNEL_H_
typedef void * VP;
#endif

#define twi_isr_C       ISRMainTwiInt
#define spi_isr_C       ISRMainSpiInt
#define sound_isr_C     ISRMainSoundInt
#define nxt_motor_isr_C ISRMainPIOAInt
#define i2c_timer_isr_C ISRMainTc0Int

#define iloc_cpu        disable_int
#define iunl_cpu        enable_int
#define kernel_exit     start

#define CONSOLE_PORTID       1
#define syslog_1(a, b, c)
#define syslog_2(a, b, c, d)
#define syslog_4(a, b, c, d, e, f)

#define NXT_AVR_TIMERID      0
#define NXT_MOTOR_TIMERID    1
#define NUM_NXT_TIMER        2


#define aic_mask_on(a)          sil_wrw_mem((VP)(TADR_AIC_BASE+TOFF_AIC_IECR), 1<<a);
#define aic_mask_off(a)         sil_wrw_mem((VP)(TADR_AIC_BASE+TOFF_AIC_IDCR), 1<<a);
#define aic_clear(a)            sil_wrw_mem((VP)(TADR_AIC_BASE+TOFF_AIC_ICCR), 1<<a);

#define systick_wait_ns(a)      sil_dly_nse(a*1000)
#define systick_suspend()       aic_mask_off(IRQ_PWM_PID)
#define systick_resume()        aic_mask_on(IRQ_PWM_PID)

#define set_time_func(no, func) rtos_1kHz_time_func[no] = func

extern void (*rtos_1kHz_time_func[NUM_NXT_TIMER])(void);

extern void twi_isr_C(void);
extern void spi_isr_C(void);
extern void i2c_timer_isr_C(void);
extern void nxt_motor_isr_C(void);
extern void sound_isr_C(void);

extern void i2c_init(long exinf);
extern void nxt_motor_init(long exinf);
extern void nxt_avr_init(long exinf);
extern void display_init(long exinf);
extern void sound_init(long exinf);

extern void rtos_init(long exinf);
extern void rtos_1kHz_process(long exinf);

extern int  systick_wait_ms(long time);


#endif /* _MACRO_ONLY */
#endif /* _RTOS_H_ */



