/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/* 
 *  ץץ(1) ECC2
 *
 *  TOPPERS Automotive KernelδŪưǧ뤿Υץץࡥ
 *
 *  ץγסPCȥܡɴ֤ǥꥢ̿Ԥ桼
 *  ޥɤ˱ưȥϤԤʤ
 *
 *  㥳ޥɰ
 *  
 *    '1' : ʹߤΥޥɤ Task1 ФƹԤ
 *    '2' : ʹߤΥޥɤ Task2 ФƹԤ
 *    '3' : ʹߤΥޥɤ Task3 ФƹԤ
 *    '4' : ʹߤΥޥɤ Task4 ФƹԤ
 *    '5' : ʹߤΥޥɤ Task5 ФƹԤ
 *  ǽ
 *    'a' : ActivateTask ˤƥư롥
 *    'A' : TerminateTask ˤƥλ롥
 *    '!'(Shift+1) : ChainTask ˤƥλTask1 ư롥
 *    '"'(Shift+2) : ChainTask ˤƥλTask2 ư롥
 *    '#'(Shift+3) : ChainTask ˤƥλTask3 ư롥
 *    '$'(Shift+4) : ChainTask ˤƥλTask4 ư롥
 *    '%'(Shift+5) : ChainTask ˤƥλTask5 ư롥
 *    's' : Υץꥨץƥ°Ǥ륿 MainTask ˤƺǹ
 *          ͥ٥ HighPriorityTask ưSchedule ˤ
 *          ƥ塼󥰤Ԥ
 *    'S' : Υץꥨץƥ֥ NonPriTask ư롥
 *          Υץꥨץƥ֥ NonPriTask ˤƺǹͥ
 *           HighPriorityTask ưλ롥
 *    'z' : GetTaskID ˤƼID롥
 *    'Z' : GetTaskState ˤƥ֤롥
 *  ߴǽ
 *    'd' : DisableAllInterrupts ¹Ը塤ϡɥͤ
 *          3ɽ EnableAllInterrupts ¹Ԥ롥
 *    'D' : SuspendAllInterrupts ¹Ը塤ϡɥͤ
 *          3ɽ SuspendAllInterrupts ¹Ը塢ϡ
 *          ͤ3ɽResumeAllInterrupts ¹Ը塢
 *          ϡɥͤ3ɽResumeAllInterrupts 
 *          ¹Ԥ롥
 *    'f' : SuspendOSInterrupts ¹Ը塤ϡɥͤ
 *          3ɽ SuspendOSInterrupts ¹Ը塢ϡ
 *          ͤ3ɽ SuspendAllInterrupts
 *          ¹Ը塤ϡɥͤ3ɽ
 *          ResumeAllInterrupts ¹Ը塢ϡɥ󥿤3
 *          ɽResumeOSInterrupts ¹Ըϡɥ
 *          ͤ3ɽResumeOSInterrupts ¹Ԥ롥
 *    'T' : ϡɥͤ3ɽ롥
 *  ꥽ǽ
 *    'k' : GetResource ˤƥ꥽ TskLevelRes 롥ʤ
 *          Task3 ϡΥ꥽ͥ٤⤤ᥨ顼Ȥʤ롥
 *    'K' : ReleaseResource ˤƥ꥽ TskLevelRes 롥
 *    'l' : GetResource ˤƥ塼꥽塤ǹͥ
 *           HighPriorityTask ưReleaseResource ˤ
 *          塼꥽롥
 *    'i' : GetResource ˤƥ꥽ IntLevelRes 塤ϡ
 *          ͤ3ɽReleaseResource ˤ
 *          ꥽ IntLevelRes 롥
 *  ٥浡ǽ
 *    'e' : SetEvent ˤƥ٥Ȥꤹ롥Task2  Task3 ʳ
 *          Ƥʤᥨ顼Ȥʤ롥
 *    'w' : ClearEvent ˤƼΥ٥Ȥ򥯥ꥢ롥Task2 
 *          Task3 ʳϳƤʤᥨ顼Ȥʤ롥
 *    'E' : GetEvent ˤƥ٥Ⱦ֤롥Task2  Task3
 *          ʳϳƤʤᥨ顼Ȥʤ롥
 *    'W' : WaitEvent ˤƼΥ٥ȤԤġTask3  Task4
 *          ʳϥ顼Ȥʤ롥
 *  顼ൡǽ
 *    'b' : GetAlarmBase ˤƥ顼 MainCycArm Υ顼١
 *          롥
 *    'B' : GetAlarm ˤƥ顼 MainCycArm λĤꥫͤ2
 *          Ϣ³Ǽ롥
 *    'v' : SetRelAlarm ˤƥ顼 ActTskArm ư500ms 
 *           Task1 ư롥
 *    'V' : SetRelAlarm ˤƥ顼 SetEvtArm ư500ms 
 *          ٥ T3Evt ꤹ롥
 *    'n' : SetRelAlarm ˤƥ顼 CallBackArm 򡤥ѥ᡼
 *          900ms λñȯ顼ꤹ롥
 *    'N' : SetRelAlarm ˤƥ顼 CallBackArm 򡤥ѥ᡼
 *          900ms λ 500ms 顼ꤹ롥
 *    'm' : SetAbsAlarm ˤƥ顼 CallBackArm 򡤥ѥ᡼
 *          900λñȯ顼ꤹ롥
 *    'M' : SetAbsAlarm ˤƥ顼 CallBackArm 򡤥ѥ᡼
 *          900λ 500ms 顼ꤹ롥
 *    'h' : CancelAlarm ˤƥ顼 CallBackArm 򥭥󥻥뤹롥
 *  ǽOSEKͳ
 *    'c' : ѳߤưˤ SignalCounter
 *          ¹Ԥ SampleCnt ˥ʥΤ롥
 *          1 ʥǥ顼 SampleArm λХå
 *          ¹Ԥ롥
 *  OS¹浡ǽ
 *    'p' : GetActiveApplicationMode ˤƥץꥱ⡼ɤ
 *          롥
 *    'q' : ShutdownOS 򥳡 E_OK Ǽ¹Ԥץץ
 *          λ롥
 *    'Q' : ShutdownOS 򥳡 E_OS_STATE Ǽ¹Ԥץץ
 *          λ롥
 *  
 *  㥪֥Ȱ
 *  OS
 *    ȥåץեå
 *    åȥեå
 *    顼եå
 *    ץ쥿եå̤
 *    ݥȥեå̤
 *    塼꥽
 *  
 *  ᥤ󥿥
 *    IDMainTask
 *    ͥ١14
 *    ¿ŵư1
 *    塼롧Υץꥨץƥ
 *    ưưAppMode1, AppMode2, AppMode3
 *    ס桼󥿥եʥꥢIOꥳޥɤ
 *          бưԤʤ
 *          顼 MainCycArm ˤꡤ100msȤԤ
 *          ޥɤμ̵ͭݡ󥰤롥
 *          ٥ȡIDMainEvtˤϢդƤ롥
 *  ǹͥ٥
 *    IDHighPriorityTask
 *    ͥ١15
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סưϤƽλ롥Υץꥨץƥ֥
 *          鵯ư졤ץꥨץȤƤ뤫ɤγǧѡ
 *  Υץꥨץƥ֥
 *    IDNonPriTask
 *    ͥ١1
 *    ¿ŵư8
 *    塼롧Υץꥨץƥ
 *    ưưʤ
 *    סưϤǹͥ٥ HighPriorityTask 
 *          ư塤λϤƥλ롥
 *  1
 *    IDTask1
 *    ͥ١4
 *    塼롧եץꥨץƥ
 *    ưưAppMode2
 *    ¿ŵư8
 *    סʥᥤ󥿥λˤưˡ
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ롥
 *          ꥽ TskLevelRes ϢդƤ롥
 *          ꥽ IntLevelRes ϢդƤ롥
 *  2
 *    IDTask2
 *    ͥ١7
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סʥᥤ󥿥λˤưˡ
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ롥
 *          ꥽ TskLevelRes ϢդƤ롥
 *          ꥽ IntLevelRes ϢդƤ롥
 *          ٥ T2Evt ϢդƤ롥
 *  3
 *    IDTask3
 *    ͥ١12
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưAppMode3
 *    סʥᥤ󥿥λˤưˡ
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ롥
 *          ٥Ԥ뤳ȤǽǤ롥
 *          ꥽ IntLevelRes ϢդƤ롥
 *          ٥ T3Evt ϢդƤ롥
 *  4
 *    IDTask4
 *    ͥ١6
 *    ¿ŵư5
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סʥᥤ󥿥λˤưˡ
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ롥
 *          ꥽ TskLevelRes ϢդƤ롥
 *          ꥽ IntLevelRes ϢդƤ롥
 *          ꥽ GroupRes ϢդƤ롥
 *  5
 *    IDTask5
 *    ͥ١9
 *    ¿ŵư5
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סʥᥤ󥿥λˤưˡ
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ롥
 *          ꥽ TskLevelRes ϢդƤ롥
 *          ꥽ IntLevelRes ϢդƤ롥
 *          ꥽ GroupRes ϢդƤ롥
 *  ߥӥ롼
 *  ꥢIO
 *    ISRIDRxHwSerialInt
 *    ͥ١6
 *    ƥꡧ1
 *    סޥɤ롥
 *  ϡɥ1
 *    ISRIDHwCnt1Int
 *    ͥ١5
 *    ƥꡧ1
 *    ס߶ػ߳ǧѥ1û롥
 *  ƥॿ޳
 *    ISRIDSysTimerInt
 *    ͥ١4
 *    ƥꡧ2
 *    סSignalCounter(SysTimerCnt) ¹Ԥ롥
 *  󥿥
 *    ISRIDCounterInt
 *    ͥ١3
 *    ƥꡧ2
 *    סSignalCounter(SampleCnt) ¹Ԥ롥
 *  ϡɥ2
 *    ISRIDHwCnt1Int
 *    ͥ١2
 *    ƥꡧ2
 *    ס߶ػ߳ǧѥ2û롥
 *          ꥽IDIntLevelResˤϢդƤ롥
 *  ꥽
 *  ٥꥽
 *    ꥽IDTskLevelRes
 *    ץѥƥɸ
 *  ߥ٥꥽
 *    ꥽IDIntLevelRes
 *    ץѥƥɸ
 *  롼ץ꥽
 *    ꥽IDGroupRes
 *    ץѥƥ
 *  ٥
 *  ᥤ󥿥٥
 *    ٥IDMainEvt
 *  2٥
 *    ٥IDT2Evt
 *  3٥
 *    ٥IDT3Evt
 *  
 *  ƥॿޥ
 *    IDSysTimerCnt
 *    ͡0999
 *    û͡1
 *  ץ륫
 *    IDSampleCnt
 *    ͡099
 *    û͡10
 *  顼
 *  ᥤ顼
 *    顼IDMainCycArm
 *    ١IDSysTimerCnt
 *    󡧥٥ MainEvt
 *    ưưAppMode1, AppMode2, AppMode3
 *    ꡧ100100
 *  ư顼
 *    顼IDActTskArm
 *    ١IDSysTimerCnt
 *    󡧥ư Task1
 *    ưưʤ
 *  ٥ꥢ顼
 *    顼IDSetEvtArm
 *    ١IDSysTimerCnt
 *    󡧥٥ T3Evt
 *    ưưʤ
 *  Хå¹ԥ顼
 *    顼IDCallBackArm
 *    ١IDSysTimerCnt
 *    󡧥Хåؿ¹
 *    ưưʤ
 *  SignalCounterǧѥ顼
 *    顼IDSampleArm
 *    ١IDSampleCnt
 *    󡧥Хåؿ¹
 *    ưưʤ
 *  ץꥱ⡼
 *  ưưʤ⡼
 *    ץꥱ⡼IDAppMode1
 *  Task1ưư⡼
 *    ץꥱ⡼IDAppMode2
 *  Task3ưư⡼
 *    ץꥱ⡼IDAppMode3
 *
 */

#include "kernel.h"
#include "sys_timer.h"
#include "serial.h"
#include "sample_config.h"
#include "kernel_id.h"
#include "sample1_com_ecc2.h"

/*
 *	ؿץȥ
 */
int main( void );
TASK( MainTask );
TASK( HighPriorityTask );
TASK( NonPriTask );
TASK( Task1 );
TASK( Task2 );
TASK( Task3 );
TASK( Task4 );
TASK( Task5 );
ALARMCALLBACK( SysTimerAlmCb );
static void		TaskProk( UINT8 task_no );

static volatile UINT8 cur_task_no = 0;

/*
 *¹ԥ
 */
#define PARALLEL_TASK_NUM	5

/*
 *  ǡХåե
 */
static volatile UINT8	command_tbl[8];	/* ޥɰϤơ֥	*/

extern const UINT8	*task_name_tbl[];


/*
 *  桼ᥤؿ
 *
 *  ץꥱ⡼ɤȽǤȡͥ뵯ư
 */
int main( void )
{
	AppModeType	crt_app_mode;

	/*
	 *  ץꥱ⡼ɤȽ
	 */
	switch( GetAppModeInfo() ){
	case 0:
		crt_app_mode = AppMode1;
		break;
	case 1:
		crt_app_mode = AppMode2;
		break;
	default:
		crt_app_mode = AppMode3;
		break;
	}

	/*
	 *  ͥ뵯ư
	 */
	StartOS( crt_app_mode );

	while( 1 );
}	/* main	*/


/*
 *  ᥤ󥿥
 *
 *  桼ޥɤμȡޥɤȤν¹ԡ
 */
TASK( MainTask )
{
	UINT8		command;
	UINT8		task_no;
	UINT8		echo[] = { " \r\n" };
	UINT8		command_error[] = { "Not ASCII character\r\n" };
	UINT8		init_lpcnt;

#ifdef MINDSTORMSNXT
	AppModeType appmode = GetActiveApplicationMode();

	ecrobot_init_nxtstate();
	show_main_screen();
	bluetooth_set_connect_state(CONSOLE_PORTID, BLUETOOTH_DEVICE_INITIALIZED);
	display_status_bar();
	ecrobot_sound_tone(1000, 200, 50);
	if(appmode == AppMode2){
		ActivateTask(Task1);
	}
	else if(appmode == AppMode3){
		ActivateTask(Task4);
	}
#endif	/* MINDSTORMSNXT */
	/*
	 *  ֹ桦ޥɥХåե
	 */
	task_no = (UINT8)( 0 );

	for( init_lpcnt=0; init_lpcnt<PARALLEL_TASK_NUM; init_lpcnt++ ){
		command_tbl[init_lpcnt] = (UINT8)( 0 );
	}

	/*
	 *  ޥɼ¹ԥ롼
	 */
	while( 1 ){
		WaitEvent( MainEvt );	/* 100msκȻԤ	*/
		ClearEvent( MainEvt );

		/*
		 *  ϥޥɼ
		 */
		RecvPolSerialChar( &command );	/* Хåեݡ	*/

		/*
		 *  ϥޥɥå
		 */
		if(command != 0 && 
			(( command <= (UINT8)( 0x1f ) ) || ( command >= (UINT8)( 0x80 ) ) )){
			PutSysLog( (const UINT8 *)command_error );
		}
		else{
			echo[0] = command;
			PutSysLog( (const UINT8 *)echo );

			/*
			 *  ޥȽ
			 */
			switch( command ){
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
				/*
				 *  оݥѹ
				 */
				task_no = (UINT8)( command - '1' );
				break;
			case 'A':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case 'z':
			case 'k':
			case 'K':
			case 'l':
			case 'i':
			case 'w':
			case 'W':
				/*
				 *  ؤΥޥ
				 */
				command_tbl[task_no] = command;
				break;
			case 0:
				command_tbl[cur_task_no] = 0xFF;
				break;
				/*
				 *  ʹߤϥᥤ󥿥ǥޥɽ
				 */
			case 'a':
				PutActTsk( task_no );
				break;
			case 's':
				PutSchedule();
				break;
			case 'S':
				PutActNonPriTsk();
				break;
			case 'Z':
				PutTaskState( task_no );
				break;
			case 'd':
				PutDisAllInt();
				break;
			case 'D':
				PutSusAllInt();
				break;
			case 'f':
				PutSusOSInt();
				break;
			case 'T':
				PutHwCnt3();
				break;
			case 'e':
				PutSetEvt( task_no );
				break;
			case 'E':
				PutGetEvt( task_no );
				break;
			case 'b':
				PutArmBase();
				break;
			case 'B':
				PutArmTick();
				PutArmTick();
				break;
			case 'v':
				/* SetRelAlarm( ActTskArm, 500, 0 );	*/
				PutSetRel(0, 0, 0);
				break;
			case 'V':
				/* SetRelAlarm( SetEvtArm, 500, 0 );	*/
				PutSetRel(1, 0, 0);
				break;
			case 'n':
				/* SetRelAlarm( CallBackArm, 900, 0 );	*/
				PutSetRel(2, 1, 0);
				break;
			case 'N':
				/* SetRelAlarm( CallBackArm, 900, 500 );	*/
				PutSetRel(2, 1, 1);
				break;
			case 'm':
				/* SetAbsAlarm( CallBackArm, 900, 0 );		*/
				PutSetAbs(2, 1, 0);
				break;
			case 'M':
				/* SetAbsAlarm( CallBackArm, 900, 500 );	*/
				PutSetAbs(2, 1, 1);
				break;
			case 'h':
				/* CancelAlarm( CallBackArm );				*/
				PutCanArm();
				break;
			case 'c':
				PutSysLog( (const UINT8 *)
							"Call SignalCounter(SampleCnt)\r\n" );
				ActCounterInt();
				break;
			case 'p':
				PutAppMode();
				break;
			case 'q':
				ShutdownOS( E_OK );
				break;
			case 'Q':
				ShutdownOS( E_OS_STATE );
				break;
			default:
				break;
			}
		}
#ifdef MINDSTORMSNXT
		FlushSerial();
#endif	/* MINDSTORMSNXT */
	}

	/*
	 *  ˤϤʤ
	 */
	PutSysLog( (const UINT8 *)"MainTask TERMINATE\r\n" );
	error_log( TerminateTask() );
}	/* TASK( MainTask )	*/


/*
 *  ǹͥ٥
 *
 *  ƥΥץꥨץȳǧѡ
 */
TASK( HighPriorityTask )
{
	PutSysLog( (const UINT8 *)"HighPriorityTask ACTIVATE\r\n" );

	error_log( TerminateTask() );
}	/* TASK( HighPriorityTask )	*/


/*
 *  Υץꥨץƥ֥
 *
 *  ¹ϥץꥨץȤʤȤγǧѡ
 */
TASK( NonPriTask )
{
	PutSysLog( (const UINT8 *)"NonPriTask ACTIVATE\r\n" );
	PutSysLog( (const UINT8 *)
				"Call ActivateTask(HighPriorityTask)\r\n" );
	error_log( ActivateTask( HighPriorityTask ) );
	PutSysLog( (const UINT8 *)"NonPriTask TERMINATE\r\n" );
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */

	error_log( TerminateTask() );
}	/* TASK( NonPriTask )	*/


/*
 *  ¹ԥ1
 */
TASK( Task1 )
{
	TaskProk( 0 );
}	/* TASK( Task1 )	*/


/*
 *  ¹ԥ2
 */
TASK( Task2 )
{
	TaskProk( 1 );
}	/* TASK( Task2 )	*/


/*
 *  ¹ԥ3
 */
TASK( Task3 )
{
	TaskProk( 2 );
}	/* TASK( Task3 )	*/


/*
 *  ¹ԥ4
 */
TASK( Task4 )
{
	TaskProk( 3 );
}	/* TASK( Task4 )	*/


/*
 *  ¹ԥ5
 */
TASK( Task5 )
{
	TaskProk( 4 );
}	/* TASK( Task5 )	*/


/*
 *  ¹ԥ
 *
 *  ᥤ󥿥Τ줿ޥɤȤν¹ԡ
 */
static void
TaskProk( UINT8 task_no )
{
	UINT8		command;	/* ޥХåե	*/
	UINT8		count = 0;

	/*
	 *  ư
	 */
#if 1	/* ROI DEBUG */
	PutSysLog( task_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)" ACTIVATE\r\n" );
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */
#endif	/* ROI DEBUG */

	/*
	 *  ޥɼ¹ԥ롼
	 */
	while( 1 ){

		/*
		 *  ޥɼ
		 */
		while( command_tbl[task_no] == 0 ) {
			cur_task_no = task_no;
		}
		command = command_tbl[task_no];
		command_tbl[task_no] = 0;

		/*
		 *  ޥȽ
		 */
		switch( command ){
		case 'A':
			PutTermTsk( task_no );
			break;
		case '!':
		case '"':
		case '#':
		case '$':
		case '%':
			PutChainTsk( task_no, ( command - '!' ) );
			break;
		case 'z':
			PutTaskID();
			break;
		case 'k':
			PutGetTskRes();
			break;
		case 'K':
			PutRelTskRes();
			break;
		case 'l':
			PutGetSchedRes();
			break;
		case 'i':
			PutGetIntRes();
			break;
		case 'w':
			PutClrEvt( task_no );
			break;
		case 'W':
			PutWaitEvt( task_no );
			break;
		default:
			count ++;
			if (count >= 5) {
				PutSysLog( task_name_tbl[task_no] );
				PutSysLog( (const UINT8 *)" is running\r\n" );
#ifdef MINDSTORMSNXT
				FlushSerial();
				{
					UINT32 count2 = 5000000;
					while(count2 > 0){
						count2--;
					}
				}
#endif	/* MINDSTORMSNXT */
				count = 0;
			}
			break;
		}
	}
}	/* TaskProk	*/



/*
 *  顼եå롼
 */
#ifdef USE_ERRORHOOK
void ErrorHook( StatusType ercd )
{
	UINT8	str_buf[16];	/* ʸХåե	*/

	/*
	 *  顼ɥ
	 */
	PutSysLog( (const UINT8 *)"Error:" );
	PutSysLog( ercd_tbl[ercd] );

	/*
	 *  顼װȤΥѥ᡼
	 */
	switch( OSErrorGetServiceId() ){
	case OSServiceId_ActivateTask:
		PutSysLog( (const UINT8 *)"=ActivateTask(" );
		ConvByte2DecStr( str_buf, OSError_ActivateTask_TaskID() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_TerminateTask:
		PutSysLog( (const UINT8 *)"=TerminateTask(" );
		break;
	case OSServiceId_ChainTask:
		PutSysLog( (const UINT8 *)"=ChainTask(" );
		ConvByte2DecStr( str_buf, OSError_ChainTask_TaskID() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_Schedule:
		PutSysLog( (const UINT8 *)"=Schedule(" );
		break;
	case OSServiceId_GetTaskID:
		PutSysLog( (const UINT8 *)"=GetTaskID(0x" );
		ConvLong2HexStr( str_buf, (UINT32)OSError_GetTaskID_TaskID() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_GetTaskState:
		PutSysLog( (const UINT8 *)"=GetTaskState(" );
		ConvByte2DecStr( str_buf, OSError_GetTaskState_TaskID() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)",0x" );
		ConvLong2HexStr( str_buf, (UINT32)OSError_GetTaskState_State() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_EnableAllInterrupts:
		PutSysLog( (const UINT8 *)"=EnableAllInterrupts(" );
		break;
	case OSServiceId_DisableAllInterrupts:
		PutSysLog( (const UINT8 *)"=DisableAllInterrupts(" );
		break;
	case OSServiceId_ResumeAllInterrupts:
		PutSysLog( (const UINT8 *)"=ResumeAllInterrupts(" );
		break;
	case OSServiceId_SuspendAllInterrupts:
		PutSysLog( (const UINT8 *)"=SuspendAllInterrupts(" );
		break;
	case OSServiceId_ResumeOSInterrupts:
		PutSysLog( (const UINT8 *)"=ResumeOSInterrupts(" );
		break;
	case OSServiceId_SuspendOSInterrupts:
		PutSysLog( (const UINT8 *)"=SuspendOSInterrupts(" );
		break;
	case OSServiceId_GetResource:
		PutSysLog( (const UINT8 *)"=GetResource(" );
		ConvByte2DecStr( str_buf, OSError_GetResource_ResID() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_ReleaseResource:
		PutSysLog( (const UINT8 *)"=ReleaseResource(" );
		ConvByte2DecStr( str_buf, OSError_ReleaseResource_ResID() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_SetEvent:
		PutSysLog( (const UINT8 *)"=SetEvent(" );
		ConvByte2DecStr( str_buf, OSError_SetEvent_TaskID() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)",0x" );
		ConvLong2HexStr( str_buf, OSError_SetEvent_Mask() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_ClearEvent:
		PutSysLog( (const UINT8 *)"=ClearEvent(0x" );
		ConvLong2HexStr( str_buf, OSError_ClearEvent_Mask() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_GetEvent:
		PutSysLog( (const UINT8 *)"=GetEvent(" );
		ConvByte2DecStr( str_buf, OSError_GetEvent_TaskID() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)",0x" );
		ConvLong2HexStr( str_buf, (UINT32)OSError_GetEvent_Mask() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_WaitEvent:
		PutSysLog( (const UINT8 *)"=WaitEvent(0x" );
		ConvLong2HexStr( str_buf, OSError_WaitEvent_Mask() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_GetAlarmBase:
		PutSysLog( (const UINT8 *)"=GetAlarmBase(" );
		ConvByte2DecStr( str_buf, OSError_GetAlarmBase_AlarmID() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)",0x" );
		ConvLong2HexStr( str_buf, (UINT32)OSError_GetAlarmBase_Info() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_GetAlarm:
		PutSysLog( (const UINT8 *)"=GetAlarm(" );
		ConvByte2DecStr( str_buf, OSError_GetAlarm_AlarmID() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)"," );
		ConvLong2DecStr( str_buf, (UINT32)OSError_GetAlarm_Tick() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_SetRelAlarm:
		PutSysLog( (const UINT8 *)"=SetRelAlarm(" );
		ConvByte2DecStr( str_buf, OSError_SetRelAlarm_AlarmID() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)"," );
		ConvLong2DecStr( str_buf, OSError_SetRelAlarm_increment() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)"," );
		ConvLong2DecStr( str_buf, OSError_SetRelAlarm_cycle() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_SetAbsAlarm:
		PutSysLog( (const UINT8 *)"=SetAbsAlarm(" );
		ConvByte2DecStr( str_buf, OSError_SetAbsAlarm_AlarmID() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)"," );
		ConvLong2DecStr( str_buf, OSError_SetAbsAlarm_start() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)"," );
		ConvLong2DecStr( str_buf, OSError_SetAbsAlarm_cycle() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_CancelAlarm:
		PutSysLog( (const UINT8 *)"=CancelAlarm(" );
		ConvByte2DecStr( str_buf, OSError_CancelAlarm_AlarmID() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case OSServiceId_GetActiveApplicationMode:
		PutSysLog( (const UINT8 *)"=GetActiveApplicationMode(" );
		break;
	case OSServiceId_StartOS:
		PutSysLog( (const UINT8 *)"=StartOS(" );
		break;
	case OSServiceId_ShutdownOS:
		PutSysLog( (const UINT8 *)"=ShutdownOS(" );
		break;
	case OSServiceId_SignalCounter:
		PutSysLog( (const UINT8 *)"=SignalCounter(" );
		ConvByte2DecStr( str_buf, OSError_SignalCounter_CounterID() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	default:
		PutSysLog( (const UINT8 *)"=UnKnownFunc(" );
		break;
	}

	PutSysLog( (const UINT8 *)")\r\n" );
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */
}	/* ErrorHook	*/
#endif /* USE_ERRORHOOK */

/*
 *  ץ쥿եå롼
 *
 *  ܥץǤ̤ѡ
 */
#ifdef USE_PRETASKHOOK
void PreTaskHook( void )
{
}	/* PreTaskHook	*/
#endif /* USE_PRETASKHOOK */

/*
 *  ݥȥեå롼
 *
 *  ܥץǤ̤ѡ
 */
#ifdef USE_POSTTASKHOOK
void PostTaskHook( void )
{
}	/* PostTaskHook	*/
#endif /* USE_POSTTASKHOOK */

/*
 *  ȥåץեå롼
 */
#ifdef USE_STARTUPHOOK
void StartupHook( void )
{
	InitSerial();		/* ꥢIO⥸塼		*/
	/* ư	*/
	PutIntSysLog( (const UINT8 *)
					"\r\nTOPPERS Automotive Kernel Release 1.0" );
#if defined( TARGET_NAME )
	PutIntSysLog( (const UINT8 *)" for " );
	PutIntSysLog( TARGET_NAME );
#endif	/* TARGET_NAME	*/
	PutIntSysLog( (const UINT8 *)
					"\r\nECC2 Sample System StartUp\r\n\r\n" );
	InitSysTimer();		/* ƥॿ޵ư				*/
#ifdef MINDSTORMSNXT
	nxt_avr_init(0);
	nxt_motor_init(0);
	sound_init(0);
	sil_dly_nse(1000*1000); /* wait for LCD to stabilize */
	display_init(0);
#endif	/* MINDSTORMSNXT */
	InitCounterInt();	/* SignalCounter¹ѳ߽	*/
	InitHwCntInt();		/* ߸ѥ󥿵ư			*/
}	/* StartupHook	*/
#endif /* USE_STARTUPHOOK */

/*
 *  åȥեå롼
 */
#ifdef USE_SHUTDOWNHOOK
void ShutdownHook( StatusType ercd )
{
	TermHwCntInt();		/* ߸ѥ			*/
	TermCounterInt();	/* SignalCounter¹ѳ	*/
	TermSysTimer();		/* ƥॿ				*/
	/* λ	*/
	PutIntSysLog( (const UINT8 *)
					"\r\nECC2 Sample System ShutDown\r\nShutDownCode:" );
	PutIntSysLog( ercd_tbl[ercd] );
	PutIntSysLog( (const UINT8 *)"\r\n\r\n" );
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */
	TermSerial();		/* ꥢIO⥸塼			*/
}	/* ShutdownHook	*/
#endif /* USE_SHUTDOWNHOOK */

/*
 *  ƥॿޤˤ륢顼ॳХå
 */
ALARMCALLBACK( SysTimerAlmCb )
{
	/*
	 *  Хå¹ԥ
	 */
	PutSysLog( (const UINT8 *)"CallBackArm Expire\r\n" );
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */
}	/* ALARMCALLBACK(SysTimerAlmCb)	*/

/*
 *  SignalCounterǧѥ顼ॳХå
 */
ALARMCALLBACK( SampleAlmCb )
{
	/*
	 *  Хå¹ԥ
	 */
	PutSysLog( (const UINT8 *)"SampleArm Expire\r\n" );
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */
}	/* ALARMCALLBACK( SampleAlmCb )	*/


