/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */
#include "kernel.h"
#include "sys_timer.h"
#include "serial.h"
#include "sample_config.h"
#include "kernel_id.h"
#include "sample1_com_ecc2.h"

/*
 *  ǡơ֥
 */
/* ̵٥ȥޥ	*/
static const EventMaskType	invalid_mask = (EventMaskType)( 0 );

/* ٥ȥޥơ֥	*/
static const EventMaskType * const	event_mask_tbl[] = {
	&invalid_mask,
	&T2Evt,
	&T3Evt,
	&invalid_mask,
	&invalid_mask
};

/* IDơ֥	*/
static const TaskType * const	task_id_tbl[] = {
	&Task1,
	&Task2,
	&Task3,
	&Task4,
	&Task5
};

/* 顼IDơ֥	*/
static const AlarmType * const	alarm_id_tbl[] = {
	&ActTskArm,
	&SetEvtArm,
	&CallBackArm
};

/* ƥåͥơ֥	*/
static const TickType	tick_tbl[] = {
	(TickType)500,
	(TickType)900
};

/* ͥơ֥	*/
static const TickType	cycle_tbl[] = {
	(TickType)0,
	(TickType)500
};

/* ٥ȥޥ̾ʸơ֥	*/
static const UINT8	*event_name_tbl[] = {
	"Invalid",
	"T2Evt",
	"T3Evt",
	"Invalid",
	"Invalid"
};

/* ̾ʸơ֥	*/
const UINT8	*task_name_tbl[] = {
	"Task1",
	"Task2",
	"Task3",
	"Task4",
	"Task5"
};

/* ʸơ֥	*/
static const UINT8	*task_state_tbl[] = {
	"SUSPENDED",
	"RUNNING",
	"READY",
	"WAITING",
};

/* 顼̾ʸơ֥	*/
static const UINT8	*alarm_name_tbl[] = {
	"ActTskArm",
	"SetEvtArm",
	"CallBackArm"
};


/* 顼ʸơ֥	*/
const UINT8	*ercd_tbl[] = {
	"E_OK",
	"E_OS_ACCESS",
	"E_OS_CALLEVEL",
	"E_OS_ID",
	"E_OS_LIMIT",
	"E_OS_NOFUNC",
	"E_OS_RESOURCE",
	"E_OS_STATE",
	"E_OS_VALUE"
};


/*
 *  ActivateTask ¹ԡϽ
 */
void
PutActTsk( UINT8 task_no )
{
	PutSysLog( (const UINT8 *)"Call ActivateTask(" );
	PutSysLog( task_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)")\r\n" );

	error_log( ActivateTask( *(task_id_tbl[task_no]) ) );

}	/* PutActTsk	*/

/*
 *  ActivateTask ¹(NonPriTask)Ͻ
 */
void
PutActNonPriTsk( void )
{
	PutSysLog( (const UINT8 *)
				"Call ActivateTask(NonPriTask)\r\n" );

	error_log( ActivateTask( NonPriTask ) );
}	/* PutActNonPriTsk	*/

/*
 *  TerminateTask ¹ԡϽ
 */
void
PutTermTsk( UINT8 task_no )
{
	StatusType	ercd;		/* 顼			*/

	PutSysLog( task_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)" TERMINATE\r\n" );

	ercd = TerminateTask();
	ShutdownOS( ercd );
}

/*
 *  ChainTask ¹ԡϽ
 */
void
PutChainTsk( UINT8 from_task_no, UINT8 to_task_no )
{
	StatusType	ercd;			/* 顼			*/

	PutSysLog( (const UINT8 *)"Call ChainTask(" );
	PutSysLog( task_name_tbl[to_task_no] );
	PutSysLog( (const UINT8 *)")\r\n" );
	PutSysLog( task_name_tbl[from_task_no] );
	PutSysLog( (const UINT8 *)" TERMINATE\r\n" );

	ercd = ChainTask( *(task_id_tbl[to_task_no]) );
	if( ercd == E_OS_LIMIT ){
		PutSysLog( (const UINT8 *)"Call TerminateTask()\r\n" );
		PutSysLog( (const UINT8 *)
					"Because of ChainTask E_OS_LIMIT return\r\n" );
		ercd = TerminateTask();
	}
	ShutdownOS( ercd );
}	/* PutChainTsk	*/

/*
 *  Schedule ¹ԡϽ
 */
void
PutSchedule( void )
{
	PutSysLog( (const UINT8 *)
				"Call ActivateTask(HighPriorityTask)\r\n" );

	error_log( ActivateTask( HighPriorityTask ) );
	PutSysLog( (const UINT8 *)"Call Schedule()\r\n" );

	error_log( Schedule() );
	PutSysLog( (const UINT8 *)"Retrun Schedule()\r\n" );
}	/* PutSchedule	*/

/*
 *  GetTaskID ¹ԡϽ
 */
void
PutTaskID( void )
{
	TaskType	task_id;		/* IDХåե		*/
	UINT8		str_buf[16];	/* ʸХåե	*/

	error_log( GetTaskID( &task_id ) );

	PutSysLog( (const UINT8 *)"TaskID:" );
	ConvByte2DecStr( str_buf, task_id );
	PutSysLog(  (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)"\r\n" );
}	/* PutTaskID	*/

/*
 *  GetTaskState ¹ԡϽ
 */
void
PutTaskState( UINT8 task_no )
{
	TaskStateType	state;		/* IDХåե		*/

	error_log( GetTaskState( *(task_id_tbl[task_no]), &state ) );

	PutSysLog( task_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)" State:" );
	PutSysLog(  task_state_tbl[state]  );
	PutSysLog( (const UINT8 *)"\r\n" );
}	/* PutTaskState	*/

/*
 *  DisableAllInterrupts/EnableAllInterrupts ¹ԡϽ
 */
void
PutDisAllInt( void )
{
	PutSysLog( (const UINT8 *)"Call DisableAllInterrupts\r\n" );

	DisableAllInterrupts();

	PutHwCnt3();
	PutIntSysLog( (const UINT8 *)"Call EnableAllInterrupts\r\n" );

	EnableAllInterrupts();
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */
}	/* PutDisAllInt	*/

/*
 *  SuspendAllInterrupts/ResumeAllInterrupts ¹ԡϽ
 */
void
PutSusAllInt( void )
{
	PutSysLog( (const UINT8 *)"Call SuspendAllInterrupts\r\n" );

	SuspendAllInterrupts();

	PutHwCnt3();
	PutIntSysLog( (const UINT8 *)"Call SuspendAllInterrupts\r\n" );

	SuspendAllInterrupts();

	PutHwCnt3();
	PutIntSysLog( (const UINT8 *)"Call ResumeAllInterrupts\r\n" );

	ResumeAllInterrupts();

	PutHwCnt3();
	PutIntSysLog( (const UINT8 *)"Call ResumeAllInterrupts\r\n" );

	ResumeAllInterrupts();
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */
}	/* PutSusAllInt	*/

/*
 *  SuspendOSInterrupts/ResumeOSInterrupts ¹ԡϽ
 */
void
PutSusOSInt( void )
{
	PutSysLog( (const UINT8 *)"Call SuspendOSInterrupts\r\n" );

	SuspendOSInterrupts();

	PutHwCnt3();
	PutSysLog( (const UINT8 *)"Call SuspendOSInterrupts\r\n" );

	SuspendOSInterrupts();

	PutHwCnt3();
	PutSysLog( (const UINT8 *)"Call SuspendAllInterrupts\r\n" );

	SuspendAllInterrupts();

	PutHwCnt3();
	PutIntSysLog( (const UINT8 *)"Call ResumeAllInterrupts\r\n" );

	ResumeAllInterrupts();

	PutHwCnt3();
	PutSysLog( (const UINT8 *)"Call ResumeOSInterrupts\r\n" );

	ResumeOSInterrupts();

	PutHwCnt3();
	PutSysLog( (const UINT8 *)"Call ResumeOSInterrupts\r\n" );

	ResumeOSInterrupts();
#ifdef MINDSTORMSNXT
	FlushSerial();
#endif	/* MINDSTORMSNXT */
}	/* PutSusOSInt	*/

/*
 *  ưƥHWͤΥϽ
 */
void
PutHwCnt3( void )
{
	UINT8	isr1_cnt;		/* ISR1 ͼХåե	*/
	UINT8	isr2_cnt;		/* ISR2 ͼХåե	*/
	UINT8	cnt;			/* ϲ				*/
	UINT8	str_buf[16];	/* ʸХåե		*/

	for( cnt = 0; cnt < 3; cnt++ ){
		GetHwCnt( &isr1_cnt, &isr2_cnt );
		PutIntSysLog( (const UINT8 *)"ISR1 Cnt:" );
		ConvByte2DecStr( str_buf, isr1_cnt );
		PutIntSysLog( (const UINT8 *)str_buf );
		PutIntSysLog( (const UINT8 *)", ISR2 Cnt:" );
		ConvByte2DecStr( str_buf, isr2_cnt );
		PutIntSysLog( (const UINT8 *)str_buf );
		PutIntSysLog( (const UINT8 *)"\r\n" );
	}
}	/* PutHwCnt3	*/

/*
 *  GetResource/ReleaseResource ¹(塼)Ͻ
 */
void
PutGetSchedRes( void )
{
	PutSysLog( (const UINT8 *)
				"Call GetResource(RES_SCHEDULER)\r\n" );
	error_log( GetResource( RES_SCHEDULER ) );
	error_log( ActivateTask( HighPriorityTask ) );
	PutSysLog( (const UINT8 *)
				"Call ReleaseResource(RES_SCHEDULER)\r\n" );
	error_log( ReleaseResource( RES_SCHEDULER ) );
}	/* PutGetSchedRes	*/

/*
 *  GetResource/ReleaseResource ¹(ߥ٥)Ͻ
 */
void
PutGetIntRes( void )
{
	PutSysLog( (const UINT8 *)
				"Call GetResource(IntLevelRes)\r\n" );
	error_log( GetResource( IntLevelRes ) );

	PutHwCnt3();
	PutSysLog( (const UINT8 *)
				"Call ReleaseResource(IntLevelRes)\r\n" );

	error_log( ReleaseResource( IntLevelRes ) );
}	/* PutGetIntRes	*/

/*
 *  GetResource ¹(٥)Ͻ
 */
void
PutGetTskRes( void )
{
	PutSysLog( (const UINT8 *)
				"Call GetResource(TskLevelRes)\r\n" );

	error_log( GetResource( TskLevelRes ) );
}	/* PutGetTskRes	*/

/*
 *  ReleaseResource ¹(٥)Ͻ
 */
void
PutRelTskRes( void )
{
	PutSysLog( (const UINT8 *)
				"Call ReleaseResource(TskLevelRes)\r\n" );

	error_log( ReleaseResource( TskLevelRes ) );
}

/*
 *  SetEvent ¹ԡϽ
 */
void
PutSetEvt( UINT8 task_no )
{
	PutSysLog( (const UINT8 *)"Call SetEvent(" );
	PutSysLog( task_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)", " );
	PutSysLog( event_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)")\r\n" );

	error_log( SetEvent( *(task_id_tbl[task_no]), *(event_mask_tbl[task_no]) ) );
}	/* PutSetEvt	*/

/*
 *  ClearEvent ¹ԡϽ
 */
void
PutClrEvt( UINT8 task_no )
{
	PutSysLog( (const UINT8 *)"Call ClearEvent(" );
	PutSysLog( event_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)")\r\n" );

	error_log( ClearEvent( *( event_mask_tbl[task_no] ) ) );
}	/* PutClrEvt	*/

/*
 *  GetEvent ¹ԡϽ
 */
 void
PutGetEvt( UINT8 task_no )
{
	EventMaskType	mask;			/* ٥ȥޥХåե	*/
	UINT8			str_buf[16];	/* ʸХåե		*/

	error_log( GetEvent( *(task_id_tbl[task_no]), &mask ) );

	PutSysLog( task_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)" Event Mask:0x" );
	ConvLong2HexStr( str_buf, mask );
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)"\r\n" );
}	/* PutGetEvt	*/

/*
 *  WaitEvent ¹ԡϽ
 */
void
PutWaitEvt( UINT8 task_no )
{
	PutSysLog( (const UINT8 *)"Call WaitEvent(" );
	PutSysLog( event_name_tbl[task_no] );
	PutSysLog( (const UINT8 *)")\r\n" );

	error_log( WaitEvent( *( event_mask_tbl[task_no] ) ) );
}	/* PutWaitEvt	*/

/*
 *  GetAlarmBase ¹ԡϽ
 */
void
PutArmBase( void )
{
	AlarmBaseType	info;			/* 顼١Хåե	*/
	UINT8			str_buf[16];	/* ʸХåե			*/

	error_log( GetAlarmBase( MainCycArm, &info) );

	PutSysLog( (const UINT8 *)
				"MainCycArm Base:\r\n\tMAXALLOWEDVALUE=" );
	ConvLong2DecStr( str_buf, info.maxallowedvalue );
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)"\r\n\tTICKSPERBASE=" );
	ConvLong2DecStr( str_buf, info.ticksperbase );
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)"\r\n\tMINCYCLE=" );
	ConvLong2DecStr( str_buf, info.mincycle );
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)"\r\n" );
}	/* PutArmBase	*/

/*
 *  PutArmTick ¹ԡϽ
 */
void
PutArmTick( void )
{
	TickType	tick;			/* ĤƥåХåե	*/
	UINT8		str_buf[16];	/* ʸХåե	*/

	error_log( GetAlarm( MainCycArm, &tick ) );

	PutSysLog( (const UINT8 *)"MainCycArm Tick:" );
	ConvLong2DecStr( str_buf, tick );
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)"\r\n" );
}	/* PutArmTick	*/

/*
 *  SetRelAlarm ¹ԡϽ
 */
void
PutSetRel( UINT8 alarm_no, UINT8 tick_no, UINT8 cycle_no )
{
	UINT8		str_buf[16];	/* ʸХåե	*/

	PutSysLog( (const UINT8 *)"Call SetRelAlarm(" );
	PutSysLog( alarm_name_tbl[alarm_no] );
	PutSysLog( (const UINT8 *)", ");
	ConvLong2DecStr(str_buf, tick_tbl[tick_no]);
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)", ");
	ConvLong2DecStr(str_buf, cycle_tbl[cycle_no]);
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)")\r\n");

	error_log( SetRelAlarm( *(alarm_id_tbl[alarm_no]),
							tick_tbl[tick_no], cycle_tbl[cycle_no] ) );
}	/* PutSetRel	*/

/*
 *  SetAbsAlarm ¹ԡϽ
 */
void
PutSetAbs( UINT8 alarm_no, UINT8 tick_no, UINT8 cycle_no )
{
	UINT8		str_buf[16];	/* ʸХåե	*/

	PutSysLog( (const UINT8 *)"Call SetAbsAlarm(" );
	PutSysLog( alarm_name_tbl[alarm_no] );
	PutSysLog( (const UINT8 *)", ");
	ConvLong2DecStr(str_buf, tick_tbl[tick_no]);
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)", ");
	ConvLong2DecStr(str_buf, cycle_tbl[cycle_no]);
	PutSysLog( (const UINT8 *)str_buf );
	PutSysLog( (const UINT8 *)")\r\n");

	error_log( SetAbsAlarm( *(alarm_id_tbl[alarm_no]),
							tick_tbl[tick_no], cycle_tbl[cycle_no] ) );
}	/* PutSetAbs	*/

/*
 *  CancelAlarm ¹ԡϽ
 */
void
PutCanArm( void )
{
	PutSysLog( (const UINT8 *)
				"Call CancelAlarm(CallBackArm)\r\n" );

	error_log( CancelAlarm( CallBackArm ) );
}	/* PutCanArm	*/

/*
 *  GetActiveApplicationMode ¹ԡϽ
 */
void
PutAppMode( void )
{
	PutSysLog( (const UINT8 *)"ActiveApplicationMode:" );
	switch( GetActiveApplicationMode() ){
	case AppMode1:
		PutSysLog( (const UINT8 *)"AppMode1\r\n" );
		break;
	case AppMode2:
		PutSysLog( (const UINT8 *)"AppMode2\r\n" );
		break;
	case AppMode3:
		PutSysLog( (const UINT8 *)"AppMode3\r\n" );
		break;
	default:
		PutSysLog( (const UINT8 *)"Non\r\n" );
		break;
	}
}	/* PutAppMode	*/

