/**
 ******************************************************************************
 **	ե̾ : sample.c
 **
 **	       : 2Ωҥ饤ȥ졼ܥåȤTOPPERS/ATK1ѥץץ
 **
 ******************************************************************************
 **/
#include "kernel.h"
#include "kernel_id.h"
#include "serial.h"
#include "ecrobot_base.h"
#include "ecrobot_private.h"
#include "ecrobot_interface.h"
#include "balancer.h" /* Ωѥإåե */

/*
 *  OILܥγ
 */
DeclareTask( TaskMotor );
DeclareCounter( SysTimerCnt );
DeclareEvent( MainEvt );

static AppModeType appmode;
static BOOL go = FALSE;
static signed char   forward;      /* ̿: -100()100()   */
static signed char   turn;         /* ̿: -100()100() */
static unsigned char fore_count;
static unsigned char turn_count;

/* Υѥ᡼ϥ󥵸/Ķ˹碌ƥ塼˥󥰤ɬפޤ */
#define GYRO_OFFSET  589 /* 㥤󥵥եå(®0[deg/sec])  */
#define WHITE		 534 /* 򿧤θ */
#define BLACK		 674 /* θ */
#define DEFFORECOUNT 800
#define DEFTURNCOUNT 4


/*
 *  ԥ󥳡ɤλ꤬ʤΥǥեȤ"1234"Ȥ
 */
#ifndef BLUETOOTH_PINCODE
#define BLUETOOTH_PINCODE       "1234"
#endif

/*
 *  ץꥱ⡼ɷѤξ
 *
 *  ƥऴȤǤդϼˡˤ뤳ȡ
 *  0,1,2Ƚ̤Ǥ뤳ȡ32Ʊˤʤ롥
 *
 *  SWʤᡢưԥ⡼ɡ1֤
 */
UINT8
GetAppModeInfo( void )
{
	return (UINT8)(0);
}	/* GetAppModeInfo	*/

/*
 *  BLUETOOTHΥԥ󥳡ɤ򤳤֤
 */
UINT8 *bluetooth_get_pincode(void)
{
	return (UINT8 *)BLUETOOTH_PINCODE;
}

/*
 *  210ʿɽ
 */
static void PutDecLog(signed char dec)
{
	UINT8 *p;
	UINT8 str[4];
	UINT32 val;

	p = str;
	if(dec >= 0)
		val = dec;
	else{
		val = -dec;
		*p++= '-';
	}
	*p++ = val / 10 + '0';
	*p++ = val % 10 + '0';
	*p++ = 0;
	PutSysLog(str);
}

/*
 *  ȥåץեå롼
 */
void StartupHook( void )
{
	InitSerial();
	InitSysTimer();
	nxt_avr_init(0);
	i2c_init(0);
	nxt_motor_init(0);
	sound_init(0);
	sil_dly_nse(1000*1000); /* wait for LCD to stabilize */
	display_init(0);
	cpp_constructor();
}	/* StartupHook	*/

void ShutdownHook(StatusType ercd)
{
	cpp_destructor();
}

/* Originally, systick_low_priority_C is a LEJOS ISR. 
 * LEJOS-OSEK uses systick_isr_C1 category 2 ISR instead of systick_low_priority_C 
 * to implement a system timer module for OSEK alarm and 
 * check the buttons status to shutdown the system
 */
ISR( UserTimerInt )
{
	static int mtimer = 0;
	/* clear the interrupt status register (2007/12/27) */
	sil_wrw_mem((VP)(TADR_AIC_BASE+TOFF_AIC_ICCR), 1<<10);

	/* check OSEK was started */ 
	if((mtimer % 4) == 0){
		if(mtimer >= 12){
			check_NXT_buttons(0);
			mtimer = 0;
		}
		if(go)
			ActivateTask(TaskMotor);
	}
	mtimer++;

	/* this function should be here to stop the NXT immediately 
	 * after EXIT button was pressed
	 */
	rtos_1kHz_process(0);
}

/*
 *  桼ᥤؿ
 *
 *  ץꥱ⡼ɤȽǤȡͥ뵯ư
 */
int main(void)
{
	AppModeType	crt_app_mode;

	/*
	 *  ץꥱ⡼ɤȽ
	 */
	switch( GetAppModeInfo() ){
	case 0:
		crt_app_mode = AppMode1;
		break;
	default:
		crt_app_mode = AppMode2;
		break;
	}

	/*
	 *  ͥ뵯ư
	 */
	StartOS( crt_app_mode );
	while( 1 );
    return 0;
}

//*****************************************************************************
// ̾	: TaskMain
// 		: ᥤ󥿥
//*****************************************************************************
TASK(TaskMain)
{
	UINT8 command;

	appmode = GetActiveApplicationMode();
	show_splash_screen();
	ecrobot_init_sensors();
	ecrobot_init_nxtstate();
	show_main_screen();
	nxt_motor_set_count(NXT_PORT_A, 0);
	nxt_motor_set_count(NXT_PORT_B, 0);
	nxt_motor_set_count(NXT_PORT_C, 0);
	bluetooth_set_connect_state(CONSOLE_PORTID, BLUETOOTH_DEVICE_INITIALIZED);
	ecrobot_init_sonar_sensor(NXT_PORT_S2); /* Ķȥ(I2C̿) */
	display_status_bar();
	ecrobot_sound_tone(1000, 200, 50);
	switch(appmode){
	case AppMode1:
		PutSysLog("Control Mode !\r\n");
		forward = 0;
		turn    = 0;
		break;
	default:
		PutSysLog("Line Trace Mode !\r\n");
		forward = 50;				/* ̿ */
		break;
	}
	fore_count = 0;
	turn_count = 0;
	FlushSerial();

	systick_wait_ms(10);
	ecrobot_set_light_sensor_active(NXT_PORT_S3);       /* ֿLEDON */
	while(1){
		/* device init should be called prior to running the application */
		ecrobot_poll_nxtstate();
		ecrobot_get_sonar_sensor(NXT_PORT_S2);
		ecrobot_status_monitor("sample ATK1"); /* LCD display */
		if(!go && ecrobot_get_touch_sensor(NXT_PORT_S1) != 0){
			balance_init();						/* Ω */
			nxt_motor_set_count(NXT_PORT_C, 0); /* ⡼󥳡ꥻå */
			nxt_motor_set_count(NXT_PORT_B, 0); /* ⡼󥳡ꥻå */
			go = TRUE;
		}
		if(appmode == AppMode1){
			RecvPolSerialChar( &command );	/* Хåեݡ	*/
			switch(command){				/* ޥȽ */
			case 'i':
				if(forward < 100)
					forward += 20;
				fore_count = DEFFORECOUNT;
				break;
			case 'm':
				if(forward > -100)
					forward -= 20;
				fore_count = DEFFORECOUNT;
				break;
			case 'k':
				if(turn > -60)
					turn -= 30;
				turn_count = DEFTURNCOUNT;
				break;
			case 'j':
				if(turn < 60)
					turn += 30;
				turn_count = DEFTURNCOUNT;
				break;
			default:
				break;
			}
			if(fore_count == 0)
				forward = 0;
			if(turn_count == 0)
				turn = 0;
			if(command >= 'a' && command <= 'z'){
				PutSysLog("foreward[");
				PutDecLog(forward);
				PutSysLog("] turn[");
				PutDecLog(turn);
				PutSysLog("]\r\n");
				FlushSerial();
			}
			if(ecrobot_get_sonar_sensor(NXT_PORT_S2) <= 30){    /* Υ¬ */
				ecrobot_sound_tone(500, 200, 100);
				fore_count = 10;
			}
		}
		WaitEvent( MainEvt );	/* 40msκȻԤ	*/
		ClearEvent( MainEvt );
    }
}

//*****************************************************************************
// ̾	: TaskMotor
// 		: ⡼
//*****************************************************************************
TASK(TaskMotor)
{
	signed char pwm_L, pwm_R; /* ⡼PWM */

	if(appmode == AppMode2){
		if (ecrobot_get_light_sensor(NXT_PORT_S3) <= (WHITE + BLACK)/2)
			turn = 50;  /*  */
		else
			turn = -50; /*  */
	}
	if(fore_count > 0)
		fore_count--;
	if(turn_count > 0)
		turn_count--;

	/* Ω(forward = 0, turn = 0ŻߥХ) */
	balance_control(
		(float)forward,                              /* ̿                 */
		(float)turn,                                 /* ̿                   */
		(float)ecrobot_get_gyro_sensor(NXT_PORT_S4), /* 㥤           */
		(float)GYRO_OFFSET,                          /* 㥤󥵥եå */
		(float)nxt_motor_get_count(NXT_PORT_C),      /* ⡼ž[deg]      */
		(float)nxt_motor_get_count(NXT_PORT_B),      /* ⡼ž[deg]      */
		(float)ecrobot_get_battery_voltage(),        /* ХåƥŰ[mV]           */
		&pwm_L,  /* ⡼PWM */
		&pwm_R); /* ⡼PWM */
	nxt_motor_set_speed(NXT_PORT_C, pwm_L, 1); /* ⡼PWMϥå */
	nxt_motor_set_speed(NXT_PORT_B, pwm_R, 1); /* ⡼PWMϥå */
	TerminateTask();
}
